org.apache.hadoop.util

## Class PureJavaCrc32

- java.lang.Object
- - org.apache.hadoop.util.PureJavaCrc32

- All Implemented Interfaces:
    Checksum

      @InterfaceAudience.Public
       @InterfaceStability.Stable
      public class PureJavaCrc32
      extends Object
      implements Checksum

  A pure-java implementation of the CRC32 checksum that uses the same polynomial as the built-in native CRC32. This is to avoid the JNI overhead for certain uses of Checksumming where many small pieces of data are checksummed in succession. The current version is ~10x to 1.8x as fast as Sun's native java.util.zip.CRC32 in Java 1.6
  See Also:
    `CRC32`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PureJavaCrc32()` Create a new PureJavaCrc32 object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getValue()`
    `void` | `reset()`
    `void` | `update(byte[] b, int offset, int len)`
    `void` | `update(int b)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PureJavaCrc32

          public PureJavaCrc32()

      Create a new PureJavaCrc32 object.

  - ### Method Detail

    - #### getValue

          public long getValue()

      Specified by:
        `getValue` in interface `Checksum`

    - #### reset

          public void reset()

      Specified by:
        `reset` in interface `Checksum`

    - #### update

          public void update(byte[] b,
                             int offset,
                             int len)

      Specified by:
        `update` in interface `Checksum`

    - #### update

          public final void update(int b)

      Specified by:
        `update` in interface `Checksum`

Copyright © 2022 Apache Software Foundation. All rights reserved.